% RNA TD5 : Regression flexible
% Auteurs : Soizic Geslin - Maxime Chambreuil
% Date : 17 Mars 2003

close all
clear all

%%%%%%%%%%%%%%%%%
% INITIALISATIONS

n = 35;
a = 0.5;
b = 10;
x = linspace(0,3.5,n);
ntest = 700;


%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%
% Dimension 1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generation des observations

y = a*x + b.*ones(1,n) + cos(exp(x))+0.25*randn(1,n);
plot(x,y,'o');hold on;


%%%%%%%%%%%%%%%%%
% Valeurs reelles
xtest = linspace(0,3.5,ntest);
Xtest = [xtest' ones(ntest,1)];
ytest = a*xtest + b.*ones(1,ntest) + cos(exp(xtest));
plot(xtest,ytest,'g');hold on;


%%%%%%%%%%%%%
% Dimension 2

X = [x' ones(n,1)];
alpha = X\y'; % Apprentissage

ychapo=[xtest' ones(ntest,1)]*alpha;

epsilonX2 = sum((ytest-ychapo').^2)

% plot(x,X*alpha,'+r');hold on;

%%%%%%%%%%%%%
% Dimension 4

X4 = [(x.^4)' (x.^3)' (x.^2)' X];
alpha4 = X4\y'; % Apprentissage
% notre nouveau vecteur alpha : a, b, c, d, e  avec f(x) = ax^4+bx^3+cx^2+dx+e
 plot(x,X4*alpha4,'+k');hold on;
% legend('observations','fonction d origine','polynome de degre 2','polynome de degre 2',4);
ychapo=[(xtest.^4)' (xtest.^3)' (xtest.^2)' xtest' ones(ntest,1)]*alpha4;
epsilonX4 = sum((ytest-ychapo').^2)

%%%%%%%%%%
% Nadaraya
sigma = 0.3;
[ychapo epsilonNadaraya] = nadarayaval(xtest,x,y,sigma);
plot(xtest,ychapo,'c');hold on;
%legend('observations','fonction d origine','Nadaraya',4);
epsilonNadaraya

%%%%%%%%%%%%%%%%%%%%%%
% Regression de spline
lambda = [10^(-6) 10^(-3) 10^(-1) 10];

figure;
for i=1:length(lambda)
subplot(4,1,i)
   plot(xtest,ytest,'g');hold on;
   [ychapo epsilonSpline] = rsplineval(xtest,x,y,lambda(i),sigma);

plot(xtest,ychapo,'r');hold off;
epsilonSpline

titre=strcat('Sigma = ',num2str(sigma));
titre=(strcat(titre,strcat(' Lambda =',num2str(lambda(i)))));
titre =strcat(titre,' ; Erreur Epsilon : ',num2str(epsilonSpline));
title(titre);
end
legend('courbe theorique','spline',4);
legend('observations','fonction d origine','polynome de degre 4','nadaraya','spline',4);
